diff --git a/lustre/ldlm/ldlm_resource.c b/lustre/ldlm/ldlm_resource.c
index 20e9e16..770605e 100644
--- a/lustre/ldlm/ldlm_resource.c
+++ b/lustre/ldlm/ldlm_resource.c
@@ -313,6 +313,9 @@ void ldlm_proc_namespace(struct ldlm_namespace *ns)
 #define ldlm_proc_namespace(ns) do {} while (0)
 #endif /* LPROCFS */
 
+/**
+ * Create and initialize new empty namespace.
+ */
 struct ldlm_namespace *ldlm_namespace_new(struct obd_device *obd, char *name,
                                           ldlm_side_t client, ldlm_appetite_t apt)
 {
@@ -399,7 +402,10 @@ out_ref:
 
 extern struct ldlm_lock *ldlm_lock_get(struct ldlm_lock *lock);
 
-/* If flags contains FL_LOCAL_ONLY, don't try to tell the server, just cleanup.
+/**
+ * Cancel and destroy all locks on a resource.
+ *
+ * If flags contains FL_LOCAL_ONLY, don't try to tell the server, just cleanup.
  * This is currently only used for recovery, and we make certain assumptions
  * as a result--notably, that we shouldn't cancel locks with refs. -phil
  *
@@ -480,6 +486,13 @@ static void cleanup_resource(struct ldlm_resource *res, cfs_list_t *q,
         EXIT;
 }
 
+/**
+ * Cancel and destroy all locks in the namespace.
+ *
+ * Typically used during evictions when server notified client that it was
+ * evicted and all of its state needs to be destroyed.
+ * Also used during shutdown.
+ */
 int ldlm_namespace_cleanup(struct ldlm_namespace *ns, int flags)
 {
         cfs_list_t *tmp;
@@ -535,6 +548,11 @@ int ldlm_namespace_cleanup(struct ldlm_namespace *ns, int flags)
         return ELDLM_OK;
 }
 
+/**
+ * Attempts to free namespace.
+ *
+ * Only used when namespace goes away, like during an unmount.
+ */
 static int __ldlm_namespace_free(struct ldlm_namespace *ns, int force)
 {
         ENTRY;
@@ -580,13 +598,13 @@ force_wait:
 }
 
 /**
- * Performs various cleanups for passed \a ns to make it drop refc and be ready
- * for freeing. Waits for refc == 0.
+ * Performs various cleanups for passed \param ns to make it drop refc and be
+ * ready for freeing. Waits for refc == 0.
  *
  * The following is done:
- * (0) Unregister \a ns from its list to make inaccessible for potential users
- * like pools thread and others;
- * (1) Clear all locks in \a ns.
+ * (0) Unregister \param ns from its list to make inaccessible for potential
+ * users like pools thread and others;
+ * (1) Clear all locks in \param ns.
  */
 void ldlm_namespace_free_prior(struct ldlm_namespace *ns,
                                struct obd_import *imp,
@@ -621,9 +639,9 @@ void ldlm_namespace_free_prior(struct ldlm_namespace *ns,
 }
 
 /**
- * Performs freeing memory structures related to \a ns. This is only done when
- * ldlm_namespce_free_prior() successfully removed all resources referencing
- * \a ns and its refc == 0.
+ * Performs freeing memory structures related to \param ns. This is only done
+ * when * ldlm_namespce_free_prior() successfully removed all resources
+ * referencing \param ns and its refc == 0.
  */
 void ldlm_namespace_free_post(struct ldlm_namespace *ns)
 {
@@ -662,8 +680,9 @@ void ldlm_namespace_free_post(struct ldlm_namespace *ns)
         OBD_FREE(ns->ns_name, strlen(ns->ns_name) + 1);
 
         /*
-         * Namespace \a ns should be not on list in this time, otherwise this
-         * will cause issues realted to using freed \a ns in pools thread.
+         * Namespace \param ns should be not on list in this time, otherwise
+         * this will cause issues realted to using freed \param ns in pools
+         * thread.
          */
         LASSERT(cfs_list_empty(&ns->ns_list_chain));
         OBD_FREE_PTR(ns);
@@ -672,7 +691,8 @@ void ldlm_namespace_free_post(struct ldlm_namespace *ns)
 }
 
 
-/* Cleanup the resource, and free namespace.
+/**
+ * Cleanup the resource, and free namespace.
  * bug 12864:
  * Deadlock issue:
  * proc1: destroy import
@@ -725,7 +745,9 @@ void ldlm_namespace_put(struct ldlm_namespace *ns, int wakeup)
         cfs_spin_unlock(&ns->ns_hash_lock);
 }
 
-/* Register @ns in the list of namespaces */
+/**
+ * Register \param ns in the list of namespaces
+ */
 void ldlm_namespace_register(struct ldlm_namespace *ns, ldlm_side_t client)
 {
         cfs_mutex_down(ldlm_namespace_lock(client));
@@ -735,7 +757,9 @@ void ldlm_namespace_register(struct ldlm_namespace *ns, ldlm_side_t client)
         cfs_mutex_up(ldlm_namespace_lock(client));
 }
 
-/* Unregister @ns from the list of namespaces */
+/**
+ * Unregister \param ns from the list of namespaces
+ */
 void ldlm_namespace_unregister(struct ldlm_namespace *ns, ldlm_side_t client)
 {
         cfs_mutex_down(ldlm_namespace_lock(client));
@@ -766,6 +790,11 @@ struct ldlm_namespace *ldlm_namespace_first_locked(ldlm_side_t client)
         return container_of(ldlm_namespace_list(client)->next,
                 struct ldlm_namespace, ns_list_chain);
 }
+
+/**
+ * Calculate hash value for a given resource name for the purposes of
+ * locating hte resource in namespace resource hash
+ */
 static __u32 ldlm_hash_fn(struct ldlm_resource *parent,
                           const struct ldlm_res_id *name)
 {
@@ -780,6 +809,9 @@ static __u32 ldlm_hash_fn(struct ldlm_resource *parent,
         return (hash & RES_HASH_MASK);
 }
 
+/**
+ * Create and initialize new resource.
+ */
 static struct ldlm_resource *ldlm_resource_new(void)
 {
         struct ldlm_resource *res;
@@ -815,7 +847,11 @@ static struct ldlm_resource *ldlm_resource_new(void)
         return res;
 }
 
-/* must be called with hash lock held */
+/**
+ * Get an existing resource reference by name.
+ *
+ * must be called with hash lock held
+ */
 static struct ldlm_resource *
 ldlm_resource_find(struct ldlm_namespace *ns, const struct ldlm_res_id *name,
                    __u32 hash)
@@ -835,7 +871,7 @@ ldlm_resource_find(struct ldlm_namespace *ns, const struct ldlm_res_id *name,
         return NULL;
 }
 
-/* Args: locked namespace
+/* Args: namespace with ns_lock held.
  * Returns: newly-allocated, referenced, unlocked resource */
 static struct ldlm_resource *
 ldlm_resource_add(struct ldlm_namespace *ns, struct ldlm_resource *parent,
@@ -901,7 +937,9 @@ ldlm_resource_add(struct ldlm_namespace *ns, struct ldlm_resource *parent,
         RETURN(res);
 }
 
-/* Args: unlocked namespace
+/**
+ * Return a reference to resource with given name creating it if necessary.
+ * Args: namespace with ns_lock unlocked
  * Locks: takes and releases ns->ns_lock and res->lr_lock
  * Returns: referenced, unlocked ldlm_resource or NULL */
 struct ldlm_resource *
@@ -1034,6 +1072,9 @@ int ldlm_resource_putref_locked(struct ldlm_resource *res)
         RETURN(rc);
 }
 
+/**
+ * Add a lock into a given resource into specified lock list.
+ */
 void ldlm_resource_add_lock(struct ldlm_resource *res, cfs_list_t *head,
                             struct ldlm_lock *lock)
 {
@@ -1053,6 +1094,11 @@ void ldlm_resource_add_lock(struct ldlm_resource *res, cfs_list_t *head,
         cfs_list_add_tail(&lock->l_res_link, head);
 }
 
+/**
+ * Insert a lock into resource after specified lock
+ *
+ * Obtain resource description from the lock we are inserting after.
+ */
 void ldlm_resource_insert_lock_after(struct ldlm_lock *original,
                                      struct ldlm_lock *new)
 {
@@ -1093,6 +1139,9 @@ void ldlm_res2desc(struct ldlm_resource *res, struct ldlm_resource_desc *desc)
         desc->lr_name = res->lr_name;
 }
 
+/**
+ * Print information about all locks in all namespaces on this node to debug log
+ */
 void ldlm_dump_all_namespaces(ldlm_side_t client, int level)
 {
         cfs_list_t *tmp;
@@ -1111,6 +1160,9 @@ void ldlm_dump_all_namespaces(ldlm_side_t client, int level)
         cfs_mutex_up(ldlm_namespace_lock(client));
 }
 
+/**
+ * Print information about all locks in this namespace on this node to debug log
+ */
 void ldlm_namespace_dump(int level, struct ldlm_namespace *ns)
 {
         cfs_list_t *tmp;
@@ -1148,6 +1200,9 @@ void ldlm_namespace_dump(int level, struct ldlm_namespace *ns)
         cfs_spin_unlock(&ns->ns_hash_lock);
 }
 
+/**
+ * Print information about all locks in this resource to debug log
+ */
 void ldlm_resource_dump(int level, struct ldlm_resource *res)
 {
         cfs_list_t *tmp;
